Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4901)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1)
@@ -257,476 +115,62 @@
 ! Description:
 ! ------------
-!> Integration in time of the model equations, statistical analysis and graphic
-!> output
+! Integration in time of the model equations, statistical analysis and graphic
+! output
 !------------------------------------------------------------------------------!
- SUBROUTINE time_integration
-
-
-    USE advec_ws,                                                                                  &
-        ONLY:  ws_statistics
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  dzu, prho, pt, pt_init, q,                                                          &
-               q_init, ref_state, rho_ocean, tend, u, v, vpt
-
-    USE biometeorology_mod,                                                                        &
-        ONLY:  bio_calculate_thermal_index_maps, thermal_comfort, bio_calculate_uv_exposure,       &
-               uv_exposure
-
-    USE bulk_cloud_model_mod,                                                                      &
-        ONLY: bulk_cloud_model, calc_liquid_water_content
-
-    USE calc_mean_profile_mod,                                                                     &
-        ONLY:  calc_mean_profile
-
-    USE chem_emissions_mod,                                                                        &
-        ONLY:  chem_emissions_setup, chem_emissions_update_on_demand
-
-    USE chem_gasphase_mod,                                                                         &
-        ONLY:  nvar
-
-    USE chem_modules,                                                                              &
-        ONLY:  bc_cs_t_val, chem_species, emissions_anthropogenic,                                 &
-               emiss_read_legacy_mode, n_matched_vars
-
-    USE control_parameters,                                                                        &
-        ONLY:  advected_distance_x, advected_distance_y, air_chemistry, average_count_3d,          &
-               averaging_interval, averaging_interval_pr, bc_lr_cyc, bc_ns_cyc, bc_pt_t_val,       &
-               bc_q_t_val, biometeorology, call_psolver_at_all_substeps,  child_domain,            &
-               constant_flux_layer, constant_heatflux, create_disturbances,                        &
-               dopr_n, constant_diffusion, coupling_mode, coupling_start_time,                     &
-               current_timestep_number, debug_output_timestep, debug_string,                       &
-               disturbance_created, disturbance_energy_limit, dist_range,                          &
-               do_sum, dt_3d, dt_averaging_input, dt_averaging_input_pr, dt_coupling,              &
-               dt_data_output_av, dt_disturb, dt_do2d_xy, dt_do2d_xz, dt_do2d_yz, dt_do3d,         &
-               dt_domask,dt_dopts, dt_dopr, dt_dopr_listing, dt_dots, dt_run_control,              &
-               end_time, first_call_lpm, first_call_mas, galilei_transformation, humidity,         &
-               indoor_model, intermediate_timestep_count, intermediate_timestep_count_max,         &
-               land_surface, large_scale_forcing, loop_optimization, lsf_surf, lsf_vert, masks,    &
-               multi_agent_system_end, multi_agent_system_start, nesting_offline, neutral,         &
-               nr_timesteps_this_run, nudging, ocean_mode, pt_reference,                           &
-               pt_slope_offset, pt_surface_heating_rate,                                           &
-               random_heatflux, run_coupled, salsa,                                                &
-               simulated_time, simulated_time_chr, skip_time_do2d_xy, skip_time_do2d_xz,           &
-               skip_time_do2d_yz, skip_time_do3d, skip_time_domask, skip_time_dopr,                &
-               skip_time_data_output_av, sloping_surface, stop_dt, surface_output,                 &
-               syn_turb_gen,                                                                       &
-               terminate_coupled, terminate_run, timestep_scheme, time_coupling, time_do2d_xy,     &
-               time_do2d_xz, time_do2d_yz, time_do3d, time_domask, time_dopr, time_dopr_av,        &
-               time_dopr_listing, time_dopts, time_dosp, time_dosp_av, time_dots, time_do_av,      &
-               time_do_sla, time_disturb, time_run_control, time_since_reference_point,            &
-               timestep_count, turbulent_inflow, turbulent_outflow, urban_surface,                 &
-               use_initial_profile_as_reference, use_single_reference_value, u_gtrans, v_gtrans,   &
-               virtual_flight, virtual_measurement, ws_scheme_mom, ws_scheme_sca
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log, log_point, log_point_s
-
-    USE diagnostic_output_quantities_mod,                                                          &
-        ONLY:  doq_calculate,                                                                      &
-               timestep_number_at_prev_calc
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz
-
-    USE flight_mod,                                                                                &
-        ONLY:  flight_measurement
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nx, nxl, nxlg, nxr, nxrg, nzb, nzt
-
-    USE indoor_model_mod,                                                                          &
-        ONLY:  dt_indoor, im_main_heatcool, time_indoor
-
+
+    USE arrays_3d
+    USE averaging
+    USE control_parameters
+    USE cpulog
+#if defined( __dvrp_graphics )
+    USE DVRP
+#endif
+    USE grid_variables
+    USE indices
+    USE interaction_droplets_ptq_mod
     USE interfaces
-
-    USE kinds
-
-    USE land_surface_model_mod,                                                                    &
-        ONLY:  lsm_boundary_condition, lsm_energy_balance, skip_time_do_lsm
-
-    USE lagrangian_particle_model_mod,                                                             &
-        ONLY:  lpm_data_output_ptseries
-
-    USE lsf_nudging_mod,                                                                           &
-        ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_actions, module_interface_swap_timelevel,                          &
-               module_interface_boundary_conditions, module_interface_exchange_horiz
-
-    USE multi_agent_system_mod,                                                                    &
-        ONLY:  agents_active, multi_agent_system
-
-    USE nesting_offl_mod,                                                                          &
-        ONLY:  nesting_offl_bc,                                                                    &
-               nesting_offl_input,                                                                 &
-               nesting_offl_interpolation_factor,                                                  &
-               nesting_offl_mass_conservation
-
-    USE netcdf_data_input_mod,                                                                     &
-        ONLY:  chem_emis, chem_emis_att
-
-    USE ocean_mod,                                                                                 &
-        ONLY:  prho_reference
-
-    USE palm_date_time_mod,                                                                        &
-        ONLY:  get_date_time
-
-    USE particle_attributes,                                                                       &
-        ONLY:  particle_advection, particle_advection_start
-
+    USE particle_attributes
     USE pegrid
-
-#if defined( __parallel )
-    USE pmc_interface,                                                                             &
-        ONLY:  nested_run, nesting_mode, pmci_boundary_conds, pmci_datatrans, pmci_synchronize,    &
-        pmci_ensure_nest_mass_conservation, pmci_ensure_nest_mass_conservation_vertical,           &
-        pmci_set_swaplevel
+    USE prognostic_equations_mod
+    USE statistics
+    USE user_actions_mod
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=9) ::  time_to_string
+    INTEGER ::  i, j, k
+
+!
+!-- At the beginning of a simulation determine the time step as well as
+!-- determine and print out the run control parameters
+    IF ( simulated_time == 0.0 )  CALL timestep
+    CALL run_control
+
+#if defined( __dvrp_graphics )
+!
+!-- Time measurement with dvrp software  
+    CALL DVRP_LOG_EVENT( 2, current_timestep_number )
 #endif
 
-    USE progress_bar,                                                                              &
-        ONLY:  finish_progress_bar, output_progress_bar
-
-    USE prognostic_equations_mod,                                                                  &
-        ONLY:  prognostic_equations_cache, prognostic_equations_vector
-
-    USE radiation_model_mod,                                                                       &
-        ONLY: dt_radiation, force_radiation_call, radiation, radiation_control,                    &
-              radiation_interaction, radiation_interactions, skip_time_do_radiation, time_radiation
-
-    USE salsa_mod,                                                                                 &
-        ONLY: aerosol_number, aerosol_mass, bc_am_t_val, bc_an_t_val, bc_gt_t_val,                 &
-              nbins_aerosol, ncomponents_mass, ngases_salsa,                                       &
-              salsa_boundary_conditions, salsa_emission_update, salsa_gas, salsa_gases_from_chem,  &
-              skip_time_do_salsa
-
-    USE spectra_mod,                                                                               &
-        ONLY: average_count_sp, averaging_interval_sp, calc_spectra, dt_dosp, skip_time_dosp
-
-    USE statistics,                                                                                &
-        ONLY:  flow_statistics_called, hom, pr_palm, sums_ls_l
-
-
-    USE surface_layer_fluxes_mod,                                                                  &
-        ONLY:  surface_layer_fluxes
-
-    USE surface_data_output_mod,                                                                   &
-        ONLY:  average_count_surf, averaging_interval_surf, dt_dosurf, dt_dosurf_av,               &
-               surface_data_output, surface_data_output_averaging, skip_time_dosurf,               &
-               skip_time_dosurf_av, time_dosurf, time_dosurf_av
-
-    USE surface_mod,                                                                               &
-        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
-
-    USE synthetic_turbulence_generator_mod,                                                        &
-        ONLY:  dt_stg_call, dt_stg_adjust, parametrize_inflow_turbulence, stg_adjust, stg_main,    &
-               time_stg_adjust, time_stg_call
-
-    USE turbulence_closure_mod,                                                                    &
-        ONLY:  tcm_diffusivities
-
-    USE urban_surface_mod,                                                                         &
-        ONLY:  usm_boundary_condition,                                                             &
-               usm_energy_balance
-
-    USE virtual_measurement_mod,                                                                   &
-        ONLY:  dt_virtual_measurement,                                                             &
-               time_virtual_measurement,                                                           &
-               vm_data_output,                                                                     &
-               vm_sampling,                                                                        &
-               vm_time_start
-
-
-    USE wind_turbine_model_mod,                                                                    &
-        ONLY:  dt_data_output_wtm, time_wtm, wind_turbine, wtm_data_output
-
-#if defined( _OPENACC )
-    USE arrays_3d,                                                                                 &
-        ONLY:  d, dd2zu, ddzu, ddzw,                                                               &
-               diss,                                                                               &
-               diss_p,                                                                             &
-               diss_l_u,                                                                           &
-               diss_l_v,                                                                           &
-               diss_l_w,                                                                           &
-               diss_s_u,                                                                           &
-               diss_s_v,                                                                           &
-               diss_s_w,                                                                           &
-               drho_air, drho_air_zw, dzw, e,                                                      &
-               flux_l_u,                                                                           &
-               flux_l_v,                                                                           &
-               flux_l_w,                                                                           &
-               flux_s_u,                                                                           &
-               flux_s_v,                                                                           &
-               flux_s_w,                                                                           &
-               heatflux_output_conversion,                                                         &
-               e_p,                                                                                &
-               pt_p,                                                                               &
-               u_p,                                                                                &
-               v_p,                                                                                &
-               w_p,                                                                                &
-               kh, km, momentumflux_output_conversion, nc, ni, nr, p, ptdf_x, ptdf_y, qc, qi, qr, rdf,     &
-               rdf_sc, rho_air, rho_air_zw, s, tdiss_m, te_m, tpt_m, tu_m, tv_m, tw_m, ug, u_init, &
-               u_stokes_zu, vg, v_init, v_stokes_zu, w, zu
-
-    USE control_parameters,                                                                        &
-        ONLY:  tsc
-
-    USE indices,                                                                                   &
-        ONLY:  advc_flags_m, advc_flags_s, nyn, nyng, nys, nysg, nz, nzb_max, wall_flags_total_0
-
-    USE statistics,                                                                                &
-        ONLY:  rmask, statistic_regions, sums_l, sums_l_l, sums_us2_ws_l,                          &
-               sums_wsus_ws_l, sums_vs2_ws_l, sums_wsvs_ws_l, sums_ws2_ws_l, sums_wspts_ws_l,      &
-               sums_wsqs_ws_l, sums_wssas_ws_l, sums_wsqcs_ws_l, sums_wsqrs_ws_l, sums_wsncs_ws_l, &
-               sums_wsnrs_ws_l, sums_wsss_ws_l, weight_substep, sums_salsa_ws_l, sums_wsqis_ws_l,  &
-               sums_wsnis_ws_l
-
-    USE surface_mod,                                                                               &
-        ONLY:  bc_h, enter_surface_arrays, exit_surface_arrays
-#endif
-
-
-    IMPLICIT NONE
-
-    CHARACTER (LEN=9) ::  time_to_string   !<
-
-    INTEGER(iwp) ::  hour                !< hour of current time
-    INTEGER(iwp) ::  hour_call_emis = -1 !< last hour where emission was called
-    INTEGER(iwp) ::  ib                  !< index for aerosol size bins
-    INTEGER(iwp) ::  ic                  !< index for aerosol mass bins
-    INTEGER(iwp) ::  icc                 !< additional index for aerosol mass bins
-    INTEGER(iwp) ::  ig                  !< index for salsa gases
-    INTEGER(iwp) ::  mid                 !< masked output running index
-    INTEGER(iwp) ::  n                   !< loop counter for chemistry species
-
-    REAL(wp) ::  dt_3d_old  !< temporary storage of timestep to be used for
-                            !< steering of run control output interval
-    REAL(wp) ::  time_since_reference_point_save  !< original value of
-                                                  !< time_since_reference_point
-
-
-!
-!-- Copy data from arrays_3d
-!$ACC DATA &
-!$ACC COPY(d(nzb+1:nzt,nys:nyn,nxl:nxr)) &
-!$ACC COPY(diss(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(e(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(u(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(v(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(w(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(kh(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(km(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
-
-!$ACC DATA &
-!$ACC COPYIN(diss_l_u(0:nz+1,nys:nyn,0), flux_l_u(0:nz+1,nys:nyn,0)) &
-!$ACC COPYIN(diss_l_v(0:nz+1,nys:nyn,0), flux_l_v(0:nz+1,nys:nyn,0)) &
-!$ACC COPYIN(diss_l_w(0:nz+1,nys:nyn,0), flux_l_w(0:nz+1,nys:nyn,0)) &
-!$ACC COPYIN(diss_s_u(0:nz+1,0), flux_s_u(0:nz+1,0)) &
-!$ACC COPYIN(diss_s_v(0:nz+1,0), flux_s_v(0:nz+1,0)) &
-!$ACC COPYIN(diss_s_w(0:nz+1,0), flux_s_w(0:nz+1,0)) &
-!$ACC COPY(diss_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(e_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(u_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(v_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(w_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(pt_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(tdiss_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(te_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(tu_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(tv_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(tw_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPY(tpt_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
-
-!$ACC DATA &
-!$ACC COPYIN(rho_air(nzb:nzt+1), drho_air(nzb:nzt+1)) &
-!$ACC COPYIN(rho_air_zw(nzb:nzt+1), drho_air_zw(nzb:nzt+1)) &
-!$ACC COPYIN(zu(nzb:nzt+1)) &
-!$ACC COPYIN(dzu(1:nzt+1), dzw(1:nzt+1)) &
-!$ACC COPYIN(ddzu(1:nzt+1), dd2zu(1:nzt)) &
-!$ACC COPYIN(ddzw(1:nzt+1)) &
-!$ACC COPYIN(heatflux_output_conversion(nzb:nzt+1)) &
-!$ACC COPYIN(momentumflux_output_conversion(nzb:nzt+1)) &
-!$ACC COPYIN(rdf(nzb+1:nzt), rdf_sc(nzb+1:nzt)) &
-!$ACC COPYIN(ptdf_x(nxlg:nxrg), ptdf_y(nysg:nyng)) &
-!$ACC COPYIN(ref_state(0:nz+1)) &
-!$ACC COPYIN(u_init(0:nz+1), v_init(0:nz+1)) &
-!$ACC COPYIN(u_stokes_zu(nzb:nzt+1), v_stokes_zu(nzb:nzt+1)) &
-!$ACC COPYIN(pt_init(0:nz+1)) &
-!$ACC COPYIN(ug(0:nz+1), vg(0:nz+1))
-
-!
-!-- Copy data from control_parameters
-!$ACC DATA &
-!$ACC COPYIN(tsc(1:5))
-
-!
-!-- Copy data from grid_variables
-!$ACC DATA &
-!$ACC COPYIN(ddx, ddy)
-
-!
-!-- Copy data from indices
-!$ACC DATA &
-!$ACC COPYIN(advc_flags_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPYIN(advc_flags_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg)) &
-!$ACC COPYIN(wall_flags_total_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg))
-
-!
-!-- Copy data from surface_mod
-!$ACC DATA &
-!$ACC COPYIN(bc_h(0:1)) &
-!$ACC COPYIN(bc_h(0)%i(1:bc_h(0)%ns)) &
-!$ACC COPYIN(bc_h(0)%j(1:bc_h(0)%ns)) &
-!$ACC COPYIN(bc_h(0)%k(1:bc_h(0)%ns)) &
-!$ACC COPYIN(bc_h(1)%i(1:bc_h(1)%ns)) &
-!$ACC COPYIN(bc_h(1)%j(1:bc_h(1)%ns)) &
-!$ACC COPYIN(bc_h(1)%k(1:bc_h(1)%ns))
-
-!
-!-- Copy data from statistics
-!$ACC DATA &
-!$ACC COPYIN(hom(0:nz+1,1:2,1:4,0)) &
-!$ACC COPYIN(rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions)) &
-!$ACC COPYIN(weight_substep(1:intermediate_timestep_count_max)) &
-!$ACC COPY(sums_l(nzb:nzt+1,1:pr_palm,0)) &
-!$ACC COPY(sums_l_l(nzb:nzt+1,0:statistic_regions,0)) &
-!$ACC COPY(sums_us2_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsus_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_vs2_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsvs_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_ws2_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wspts_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wssas_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsqs_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsqcs_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsqis_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsqrs_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsncs_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsnis_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsnrs_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_wsss_ws_l(nzb:nzt+1,0)) &
-!$ACC COPY(sums_salsa_ws_l(nzb:nzt+1,0))
-
-!
-!-- Next statement is to avoid compiler warnings about unused variables. Please
-!-- remove in case that you are using them. ddx and ddy need to be defined in
-!-- time_integration because of ACC COPYIN directive.
-    ddx = ddx
-    ddy = ddy
-
-#if defined( _OPENACC )
-    CALL enter_surface_arrays
-#endif
-
-!
-!-- At beginning determine the first time step
-    CALL timestep
-
-#if defined( __parallel )
-!
-!-- Synchronize the timestep in case of nested run.
-    IF ( nested_run )  THEN
-!
-!--    Synchronization by unifying the time step.
-!--    Global minimum of all time-steps is used for all.
-       CALL pmci_synchronize
-    ENDIF
-#endif
-
-!
-!-- Determine and print out the run control quantities before the first time
-!-- step of this run. For the initial run, some statistics (e.g. divergence)
-!-- need to be determined first --> CALL flow_statistics at the beginning of
-!-- run_control
-    CALL run_control
-!
-!-- Data exchange between coupled models in case that a call has been omitted
-!-- at the end of the previous run of a job chain.
-    IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled )  THEN
-!
-!--    In case of model termination initiated by the local model the coupler
-!--    must not be called because this would again cause an MPI hang.
-       DO WHILE ( time_coupling >= dt_coupling  .AND.  terminate_coupled == 0 )
-          CALL surface_coupler
-          time_coupling = time_coupling - dt_coupling
-       ENDDO
-       IF (time_coupling == 0.0_wp  .AND.  time_since_reference_point < dt_coupling )  THEN
-          time_coupling = time_since_reference_point
-       ENDIF
-    ENDIF
-
-    CALL location_message( 'atmosphere (and/or ocean) time-stepping', 'start' )
 !
 !-- Start of the time loop
-    DO  WHILE ( simulated_time < end_time  .AND.  .NOT. stop_dt  .AND. .NOT. terminate_run )
+    DO  WHILE ( simulated_time < end_time  .AND.  .NOT. stop_dt  .AND. &
+                .NOT. terminate_run )
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'start' )
 
-       IF ( debug_output_timestep )  THEN
-           WRITE( debug_string, * ) 'time_integration', simulated_time
-           CALL debug_message( debug_string, 'start' )
-       ENDIF
-
-!
-!--    Determine ug, vg and w_subs in dependence on data from external file
-!--    LSF_DATA
-       IF ( large_scale_forcing .AND. lsf_vert )  THEN
-           CALL ls_forcing_vert ( simulated_time )
-           sums_ls_l = 0.0_wp
-       ENDIF
-
-!
-!--    Set pt_init and q_init to the current profiles taken from
-!--    NUDGING_DATA
-       IF ( nudging )  THEN
-           CALL nudge_ref ( simulated_time )
-!
-!--        Store temperature gradient at the top boundary for possible Neumann
-!--        boundary condition
-           bc_pt_t_val = ( pt_init(nzt+1) - pt_init(nzt) ) / dzu(nzt+1)
-           bc_q_t_val  = ( q_init(nzt+1) - q_init(nzt) ) / dzu(nzt+1)
-           IF ( air_chemistry )  THEN
-              DO  n = 1, nvar
-                 bc_cs_t_val = (  chem_species(n)%conc_pr_init(nzt+1)                              &
-                                - chem_species(n)%conc_pr_init(nzt) )                              &
-                               / dzu(nzt+1)
-              ENDDO
-           ENDIF
-           IF ( salsa  .AND.  time_since_reference_point >= skip_time_do_salsa )  THEN
-              DO  ib = 1, nbins_aerosol
-                 bc_an_t_val = ( aerosol_number(ib)%init(nzt+1) - aerosol_number(ib)%init(nzt) ) / &
-                               dzu(nzt+1)
-                 DO  ic = 1, ncomponents_mass
-                    icc = ( ic - 1 ) * nbins_aerosol + ib
-                    bc_am_t_val = ( aerosol_mass(icc)%init(nzt+1) - aerosol_mass(icc)%init(nzt) ) /&
-                                  dzu(nzt+1)
-                 ENDDO
-              ENDDO
-              IF ( .NOT. salsa_gases_from_chem )  THEN
-                 DO  ig = 1, ngases_salsa
-                    bc_gt_t_val = ( salsa_gas(ig)%init(nzt+1) - salsa_gas(ig)%init(nzt) ) /        &
-                                  dzu(nzt+1)
-                 ENDDO
-              ENDIF
-           ENDIF
-       ENDIF
-!
-!--    Input of boundary data.
-       IF ( nesting_offline )  CALL nesting_offl_input
-!
-!--    Execute all other module actions routines
-       CALL module_interface_actions( 'before_timestep' )
+!
+!--    Determine size of next time step
+       IF ( simulated_time /= 0.0 )  CALL timestep
+
+!
+!--    Execute the user-defined actions
+       CALL user_actions( 'before_timestep' )
 
 !
 !--    Start of intermediate step loop
        intermediate_timestep_count = 0
-       DO  WHILE ( intermediate_timestep_count < intermediate_timestep_count_max )
+       DO  WHILE ( intermediate_timestep_count < &
+                   intermediate_timestep_count_max )
 
           intermediate_timestep_count = intermediate_timestep_count + 1
@@ -737,49 +181,4 @@
           CALL timestep_scheme_steering
 
-!
-!--       Calculate those variables needed in the tendency terms which need
-!--       global communication
-          IF ( .NOT. use_single_reference_value  .AND.  .NOT. use_initial_profile_as_reference )   &
-          THEN
-!
-!--          Horizontally averaged profiles to be used as reference state in
-!--          buoyancy terms (WARNING: only the respective last call of
-!--          calc_mean_profile defines the reference state!)
-             IF ( .NOT. neutral )  THEN
-                CALL calc_mean_profile( pt, 4 )
-                ref_state(:)  = hom(:,1,4,0) ! this is used in the buoyancy term
-             ENDIF
-             IF ( ocean_mode )  THEN
-                CALL calc_mean_profile( rho_ocean, 64 )
-                ref_state(:)  = hom(:,1,64,0)
-             ENDIF
-             IF ( humidity )  THEN
-                CALL calc_mean_profile( vpt, 44 )
-                ref_state(:)  = hom(:,1,44,0)
-             ENDIF
-!
-!--          Assure that ref_state does not become zero at any level
-!--          ( might be the case if a vertical level is completely occupied
-!--            with topography ).
-             ref_state = MERGE( MAXVAL(ref_state), ref_state, ref_state == 0.0_wp )
-          ENDIF
-
-          IF ( ( ws_scheme_mom .OR. ws_scheme_sca )  .AND.  intermediate_timestep_count == 1 )     &
-          THEN
-             CALL ws_statistics
-          ENDIF
-!
-!--       In case of nudging calculate current nudging time scale and horizontal
-!--       means of u, v, pt and q
-          IF ( nudging )  THEN
-             CALL calc_tnudge( simulated_time )
-             CALL calc_mean_profile( u, 1 )
-             CALL calc_mean_profile( v, 2 )
-             CALL calc_mean_profile( pt, 4 )
-             CALL calc_mean_profile( q, 41 )
-          ENDIF
-!
-!--       Execute all other module actions routines
-          CALL module_interface_actions( 'before_prognostic_equations' )
 !
 !--       Solve the prognostic equations. A fast cache optimized version with
@@ -788,18 +187,34 @@
 !--       in the other versions a good vectorization is prohibited due to
 !--       inlining problems.
-          IF ( loop_optimization == 'cache' )  THEN
-             CALL prognostic_equations_cache
-          ELSEIF ( loop_optimization == 'vector' )  THEN
-             CALL prognostic_equations_vector
-          ENDIF
-
-!
-!--       Movement of agents in multi agent system
-          IF ( agents_active  .AND.  time_since_reference_point >= multi_agent_system_start  .AND. &
-               time_since_reference_point <= multi_agent_system_end  .AND.                         &
-               intermediate_timestep_count == 1 )                                                  &
+          IF ( host(1:3) == 'nec' )  THEN
+             CALL prognostic_equations_vec
+          ELSE
+             IF ( momentum_advec == 'ups-scheme'  .OR.  &
+                  scalar_advec == 'ups-scheme'   .OR.  &
+                  scalar_advec == 'bc-scheme' )        &
+             THEN
+                CALL prognostic_equations
+             ELSE
+                CALL prognostic_equations_fast
+             ENDIF
+          ENDIF
+
+!
+!--       Particle advection (only once during intermediate steps, because
+!--       it uses an Euler-step)
+          IF ( simulated_time >= particle_advection_start  .AND. &
+               intermediate_timestep_count == 1 )  THEN
+             CALL advec_particles
+             first_call_advec_particles = .FALSE.
+          ENDIF
+
+!
+!--       Interaction of droplets with temperature and specific humidity.
+!--       Droplet condensation and evaporation is calculated within
+!--       advec_particles.
+          IF ( cloud_droplets  .AND.  &
+               intermediate_timestep_count == intermediate_timestep_count_max )&
           THEN
-             CALL multi_agent_system
-             first_call_mas = .FALSE.
+             CALL interaction_droplets_ptq
           ENDIF
 
